import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { DealerReferee, DealerRefereeParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询分销商推荐关系表
 */
export async function pageDealerReferee(params: DealerRefereeParam) {
  const res = await request.get<ApiResult<PageResult<DealerReferee>>>(
    MODULES_API_URL + '/shop/dealer-referee/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询分销商推荐关系表列表
 */
export async function listDealerReferee(params?: DealerRefereeParam) {
  const res = await request.get<ApiResult<DealerReferee[]>>(
    MODULES_API_URL + '/shop/dealer-referee',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加分销商推荐关系表
 */
export async function addDealerReferee(data: DealerReferee) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-referee',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改分销商推荐关系表
 */
export async function updateDealerReferee(data: DealerReferee) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-referee',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除分销商推荐关系表
 */
export async function removeDealerReferee(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-referee/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除分销商推荐关系表
 */
export async function removeBatchDealerReferee(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-referee/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询分销商推荐关系表
 */
export async function getDealerReferee(id: number) {
  const res = await request.get<ApiResult<DealerReferee>>(
    MODULES_API_URL + '/shop/dealer-referee/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
